package org.processmining.plugins.cheetah.ppmchart;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.cheetah.ppmchart.model.PPMChartModel;

public class PPMChartAnalysisPlugin {
			        
	@Plugin(name = "PPMChart Analysis", 
			parameterLabels = { "log" }, 
			returnLabels = { "PPMChart Analysis" }, 
			returnTypes = { PPMChartModel.class }, 
			userAccessible = true, 
			help = "Analyze the process of process modeling using PPMChart")
	@UITopiaVariant(uiLabel = "PPMChart Analysis", 
			        affiliation = "Ghent University",
			        author = "J. Claes", 
			        email = "jan.claes@ugent.be",
			        website = "http://processmining.ugent.be")
	public static PPMChartModel makeChart(PluginContext context, XLog log) {
		return new PPMChartModel(context, log);
	}
}
