package org.processmining.plugins.cheetah.ppmchart.model;

import javax.swing.table.AbstractTableModel;

public class OverallMetricTableModel extends AbstractTableModel {

	private static final long serialVersionUID = -2720292789575028501L;

	private final String[] columnNames = { "items", "values" };
	private final Object[][] data = { { "time(first)", "" }, { "time(end)", "" }, { "avg spread", "" },
			{ "min spread", "" }, { "max spread", "" } };

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return data.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

	public Class<?> getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public void setValueAt(Object value, int row, int col) {
		data[row][col] = value;
		fireTableCellUpdated(row, col);
	}

	public void setHeadings(String one, String two) {
		columnNames[0] = one;
		columnNames[1] = two;
	}

}
