package org.processmining.plugins.cheetah.ppmchart.ui;

import java.util.HashMap;

public class ShapeReference {
	public static String ITEM_HANDLE_DOT = "Dot";
	public static String ITEM_HANDLE_CIRCLE = "Circle";
	public static String ITEM_HANDLE_TRIANGLE = "Triangle";
	public static String ITEM_HANDLE_BOX = "Box";
	public static String ITEM_HANDLE_RHOMBUS = "Rhombus";
	public static String ITEM_HANDLE_ROUND_BOX = "RoundBox";
	public static String ITEM_HANDLE_DRAW_BOX = "DrawBox";
	public static String ITEM_HANDLE_DRAW_CIRCLE = "Circle";
	public static String ITEM_HANDLE_DRAW_TRIANGLE = "Triangle";
	public static String ITEM_HANDLE_DRAW_RHOMBUS = "DrawRhombusBox";
	public static String ITEM_HANDLE_DRAW_ROUND_BOX = "DrawRoundBox";
	public static String[] shapeList = new String[] { ITEM_HANDLE_CIRCLE, ITEM_HANDLE_TRIANGLE, ITEM_HANDLE_BOX,
			ITEM_HANDLE_RHOMBUS, ITEM_HANDLE_ROUND_BOX, ITEM_HANDLE_DRAW_CIRCLE, ITEM_HANDLE_DRAW_TRIANGLE,
			ITEM_HANDLE_DRAW_BOX, ITEM_HANDLE_DRAW_ROUND_BOX, ITEM_HANDLE_DRAW_RHOMBUS };
	public static int index = 0;

	protected HashMap<String, String> mappings = null;
	protected boolean[] assigned = null;

	public ShapeReference() {
		mappings = new HashMap<String, String>();
		mappings.put("CREATE_ACTIVITY", ITEM_HANDLE_CIRCLE);
		mappings.put("CREATE_AND", ITEM_HANDLE_BOX);
		mappings.put("CREATE_EDGE", ITEM_HANDLE_TRIANGLE);
		mappings.put("CREATE_EDGE_BENDPOINT", ITEM_HANDLE_TRIANGLE);
		mappings.put("CREATE_END_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("CREATE_START_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("CREATE_XOR", ITEM_HANDLE_BOX);
		mappings.put("DELETE_ACTIVITY", ITEM_HANDLE_CIRCLE);
		mappings.put("DELETE_AND", ITEM_HANDLE_BOX);
		mappings.put("DELETE_EDGE", ITEM_HANDLE_TRIANGLE);
		mappings.put("DELETE_EDGE_BENDPOINT", ITEM_HANDLE_TRIANGLE);
		mappings.put("DELETE_END_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("DELETE_START_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("DELETE_XOR", ITEM_HANDLE_BOX);
		mappings.put("MOVE_ACTIVITY", ITEM_HANDLE_CIRCLE);
		mappings.put("MOVE_AND", ITEM_HANDLE_BOX);
		mappings.put("MOVE_EDGE_BENDPOINT", ITEM_HANDLE_TRIANGLE);
		mappings.put("MOVE_EDGE_LABEL", ITEM_HANDLE_TRIANGLE);
		mappings.put("MOVE_END_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("MOVE_START_EVENT", ITEM_HANDLE_RHOMBUS);
		mappings.put("MOVE_XOR", ITEM_HANDLE_BOX);
		mappings.put("RECONNECT_EDGE", ITEM_HANDLE_TRIANGLE);
		mappings.put("NAME_ACTIVITY", ITEM_HANDLE_CIRCLE);
		mappings.put("NAME_EDGE", ITEM_HANDLE_TRIANGLE);
		mappings.put("RENAME_ACTIVITY", ITEM_HANDLE_CIRCLE);
		mappings.put("RENAME_EDGE", ITEM_HANDLE_TRIANGLE);
	}

	public String getShape(String key) {
		if (mappings.containsKey(key)) {
			// return previously mapped color
			return mappings.get(key);
		} else {
			// assign shape
			String str = shapeList[index % 8];
			index++;
			mappings.put(key, str);
			return str;
		}
	}
}
